/* wineautorun: A Wine addon to parse and execute Autorun scripts. 
 * Takes one argument: A drive letter without the trailing ':' (colon)
 */

typedef struct {
	char name[256];
	char val[256];
} IniFmt;

#include <stdio.h>
#include <stdlib.h>

char lowerc(char c)
{
	if (c >= 'A' && c <= 'Z') 
		c -= 'A' - 'a';
	return c;
}

void lowers(char *str)
{
	int len = strlen(str);
	int x;
	for(x=0;x<(len);x++) { 
		str[x] = lowerc(str[x]);
	};
}

int main(int argc, char **argv)
{
	char *tmp, *tmpx, *tmpy, *tmpz;
	FILE *fd;
	int x = 0;
	IniFmt ini;
	tmpx = malloc(256);
	tmpy = malloc(256);
	memset(tmpx,0,256);
	memset(tmpy,0,256);
	if (argc != 2) {

		fprintf(stderr,"err: wineautorun: Please specify a drive letter.\n");
		free(tmp);
		free(tmpx);
		free(tmpy);
		exit(1);
	} /* No drive letter */

	if ((argv[1][0] >= 'A' && argv[1][0] <= 'Z') || 
		(argv[1][0] >= 'a' && argv[1][0] <= 'z')) {
		asprintf(&tmp,"%c%s",argv[1][0],":\\autorun.inf");
		fd = fopen(tmp,"r");
		if (fd == NULL) {
			fprintf(stderr, "err: wineautorun: ");
			perror(tmp);
			free(tmp);
			free(tmpx);
			free(tmpy);
			exit(1);
		} /* File was unreadable */
		x=0;
		fscanf(fd,"%s\r",tmpy);
		tmpx = strndup(tmpy,x-1);
		lowers(tmpx);
		if (strcmp(tmpx,"[autorun]")!=0) {
			fprintf(stderr,
			"err: winautorun: %s: Not an autorun file!\n",tmp);
			free(tmp);
			free(tmpx);
			free(tmpy);
			exit(1);
		}
		while(feof(fd) == 0) {
			x=0;
			memset(ini.name,0,256);
			memset(ini.val,0,256);
			/* A bit hackish, but it works. */
			do {
				tmpx[1] = '\0';
				fread(tmpx,1,1,fd);
				if (tmpx[0] == '=') {
				} else {
					strcat(ini.name,tmpx);
					x++;
				}
			} while (tmpx[0] != '=');
			do {
				fscanf(fd,"%s\r",ini.val);
				lowers(ini.name);
				if(strcmp(ini.name,"autorun") == 0) {
					free(tmp);
					asprintf(&tmp,"%c:\\%s",argv[1][0],ini.val);
					/* Usually crashes right about... here. */
					execlp(tmp,tmp,0);
					free(tmp);
					free(tmpy);
					free(tmpx);				
					exit(1);
				}
			} while (feof(fd) == 0);
		};
	}
	/* Check to see if tmp needs to be free()'d */
	free(tmpy);
	free(tmpx);
	exit(1);
}

